summaryrefslogtreecommitdiff
path: root/tests/misc/sum-sysv
diff options
context:
space:
mode:
Diffstat (limited to 'tests/misc/sum-sysv')
-rwxr-xr-xtests/misc/sum-sysv60
1 files changed, 60 insertions, 0 deletions
diff --git a/tests/misc/sum-sysv b/tests/misc/sum-sysv
new file mode 100755
index 000000000..5181cff0a
--- /dev/null
+++ b/tests/misc/sum-sysv
@@ -0,0 +1,60 @@
+#!/bin/sh
+# make sure `sum -s' works for input whose sum of bytes is larger than 2^32
+
+# Copyright (C) 2001-2004, 2006-2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ sum --version
+fi
+
+$PERL -e 1 > /dev/null 2>&1 || {
+ echo 1>&2 "$0: configure didn't find a usable version of Perl," \
+ "so can't run this test"
+ exit 77
+}
+
+# Avoid a problem when run in a UTF-8 locale.
+# Otherwise, Perl would try to (and fail to) interpret
+# each string below as a sequence of multi-byte characters.
+LC_ALL=C
+export LC_ALL
+
+. $srcdir/../test-lib.sh
+
+fail=0
+
+# FYI, 16843009 is floor (2^32 / 255).
+
+# aka: perl -e 'print chr(255) x 16843009'
+$PERL -e '$s = chr(255) x 65537; foreach (1..257) {print $s}' \
+ | sum -s > out || fail=1
+cat > exp <<\EOF
+65535 32897
+EOF
+compare out exp || fail=1
+
+rm -f out exp
+
+# aka: perl -e 'print chr(255) x 16843010'
+$PERL -e '$s = chr(255) x 65537; foreach (1..257) {print $s}; print chr(255)' \
+ | sum -s > out || fail=1
+cat > exp <<\EOF
+254 32897
+EOF
+compare out exp || fail=1
+
+(exit $fail); exit $fail